uart_free_protocol = 1

local sc_Home = 0

local Func_lampState = 0x01
local Func_lampLight = 0x02

local buff        = {}
local cmd_length  = 0
local cmd_end_tag = 0
	
local judge_lamp1_light = 0



--calculate CRC16
--@data : t, data to be verified
--@n    : number of verified
--@return : check result
function add_crc16(start, n, data)
	
	local carry_flag, a = 0
    local result = 0xffff
    local i = start

	while(true)
	do
		result = result ~ data[i]
		for j = 0, 7
        do
            a = result
            carry_flag = a & 0x0001
            result = result >> 1
            if carry_flag == 1
            then
                 result = result ~ 0xa001
            end
        end
		
		i = i + 1
		if i == start + n
		then
			break
		end
	end

    return result
end


-- Calculate checksum 
-- @buffTb: check table
function my_cal_checksum(buffTb)
	
	local check_sum = 0

	for i = 0, #(buffTb)-1
	do
		check_sum = check_sum + buffTb[i]
	end
	
	return (check_sum & 0xFF)
end

--set the lamp state
--@xth_lamp:which lamp
--@xth_lamp_style: state of lamp 0-colse,1-open
function my_set_lamp_state(xth_lamp, xth_lamp_state)
	
	if xth_lamp == 1
	then
		set_value(sc_Home, 1, xth_lamp_state)	
	end
end

--set the style of the lamp
--@xth_lamp : which lamp
--@xth_lamp_style: style of lamp 
function my_set_lamp_light(xth_lamp, xth_lamp_light)
	
	if xth_lamp == 1
	then
		set_value(sc_Home, 2, xth_lamp_light)	
	end
end

--send notify of lamp status
--@xth_lamp: which lamp
--@state: state of lamp 0-colse,1-open
function my_uartsend_lampstate_notify(xth_lamp,state)

	local lamp_state_notify = {}

	lamp_state_notify[0]  = Func_lampState
	lamp_state_notify[1]  = xth_lamp
	lamp_state_notify[2]  = state
	
	uart_send_data(lamp_state_notify)
end	

--send notify of lamp brightness
function my_uartsend_lamplight_notify(xth_lamp)

	local xth_lamp_light    = 0
	local lamp_light_notify = {}
	
	if xth_lamp == 1
	then
		xth_lamp_light = get_value(sc_Home, 2)
	end
	
	lamp_light_notify[0]  = Func_lampLight
	lamp_light_notify[1]  = xth_lamp
	lamp_light_notify[2]  = xth_lamp_light

	uart_send_data(lamp_light_notify)
end

--Instruction analysis
--@msg:data table
function my_processmessage(msg)
	
	local funccode = msg[0]

	if funccode == Func_lampState
	then
		
		local xth_lamp = msg[1]
		local xth_lamp_state = msg[2]
		my_set_lamp_state(xth_lamp, xth_lamp_state)
		
	elseif funccode == Func_lampLight
	then
		local xth_lamp = msg[1]
		local xth_lamp_light =  msg[2]
		my_set_lamp_light(xth_lamp, xth_lamp_light)
	end
end

-- ϵͳ: ʼ
function on_init()
	uart_set_timeout(0, 0)
end

local buff         = {}             --
local cmd_length   = 0              --֡

-- ϵͳ: ڽպ
function on_uart_recv_data(packet)

	local recv_packet_size = (#(packet))
	local check16          = 0
	
	for i = 0, recv_packet_size 
	do
		buff[cmd_length] = packet[i]
		cmd_length = cmd_length + 1
	
		if cmd_length == 3 
		then
			my_processmessage(buff)

			buff         = {}
			cmd_length   = 0
		end
	end
end


-- ϵͳ: ص
function on_press(state,x,y)
	local cur_screen = get_current_screen() 
	
	if state == 0 and cur_screen == sc_Home
	then
		if judge_lamp1_light == 1
		then
			my_uartsend_lamplight_notify(1)
		
			judge_lamp1_light = 0
		end
 	end
end

--ûͨ޸Ŀؼִд˻ص
--ťؼ޸ıؼ޸Ļᴥ¼
function on_control_notify(screen,control,value)
	
	--ص
	if screen == sc_Home and control == 1
	then
		my_uartsend_lampstate_notify(1, value)
		
	--
	elseif screen == sc_Home and control == 2
	then
		judge_lamp1_light = 1
	end
	
end